/* istanbul ignore file */

const { callAuditLogContinuation, isRelevantOperation } = require('../../cds-services/services/utils/personalData')

/**
 * Finishes the audit logging in case of a data change event and commit.
 *
 * @param result - the result of the event
 * @param req - the context object
 * @returns {Promise}
 */
module.exports = function (result, req) {
  if (isRelevantOperation(req.event, req.target) && req._.auditLogContinuation) {
    return callAuditLogContinuation(req, 'after commit')
  }
}
