'use strict'

const AbstractError = require('./AbstractError')

/**
 * @extends AbstractError
 */
class NotImplementedError extends AbstractError {
  /**
   * Creates an instance of NotImplementedError.
   * If an error message is not provided, the default message would be 'Not Implemented'.
   * @param {string} message the error message
   */
  constructor (message) {
    super(AbstractError.ErrorNames.NOT_IMPLEMENTED, message || 'Not implemented')
  }
}

module.exports = NotImplementedError
