'use strict'

const Expression = require('./Expression')

/**
 * @extends Expression
 * @hideconstructor
 */
class TypeLiteralExpression extends Expression {
  /**
   * Create an instance of TypeLiteralExpression.
   * @param {?EdmType} type EDM type corresponding to this literal type (null is a valid type)
   */
  constructor (type) {
    super(Expression.ExpressionKind.TYPE_LITERAL)
    this._type = type
  }

  /**
   * Return the EDM type of this expression, i.e., the defined type (null is a valid type).
   * @returns {?EdmType} the EDM type of this expression (can be null)
   */
  getType () {
    return this._type
  }
}

module.exports = TypeLiteralExpression
