'use strict'

const Transformation = require('./Transformation')

/**
 * Represents an expand transformation.
 * @extends Transformation
 * @hideconstructor
 */
class ExpandTransformation extends Transformation {
  constructor () {
    super(Transformation.TransformationKind.EXPAND)

    this._expand = null
  }

  /**
   * Returns the expand item.
   * @returns {ExpandItem} the expand item
   */
  getExpand () {
    return this._expand
  }

  /**
   * Sets the expand item.
   * @param {ExpandItem} expand the expand item
   * @returns {ExpandTransformation} this transformation
   * @package
   */
  setExpand (expand) {
    this._expand = expand
    return this
  }
}

module.exports = ExpandTransformation
