'use strict'

const Transformation = require('./Transformation')

/**
 * Represents a filter transformation.
 * @extends Transformation
 * @hideconstructor
 */
class FilterTransformation extends Transformation {
  constructor () {
    super(Transformation.TransformationKind.FILTER)

    this._filter = null
  }

  /**
   * Returns the filter expression.
   * @returns {Expression} the filter expression
   */
  getFilter () {
    return this._filter
  }

  /**
   * Sets the filter expression.
   * @param {Expression} filter the filter expression
   * @returns {FilterTransformation} this transformation
   * @package
   */
  setFilter (filter) {
    this._filter = filter
    return this
  }
}

module.exports = FilterTransformation
