'use strict'

const Transformation = require('./Transformation')

/**
 * Represents a search transformation.
 * @extends Transformation
 * @hideconstructor
 */
class SearchTransformation extends Transformation {
  constructor () {
    super(Transformation.TransformationKind.SEARCH)

    this._search = null
  }

  /**
   * Returns the search expression.
   * @returns {Expression} the search expression
   */
  getSearch () {
    return this._search
  }

  /**
   * Sets the search expression.
   * @param {Expression} search the search expression
   * @returns {SearchTransformation} this transformation
   * @package
   */
  setSearch (search) {
    this._search = search
    return this
  }
}

module.exports = SearchTransformation
