'use strict'

const Transformation = require('./Transformation')

/**
 * Represents a top transformation.
 * @extends Transformation
 * @hideconstructor
 */
class TopTransformation extends Transformation {
  constructor () {
    super(Transformation.TransformationKind.TOP)

    this._top = null
  }

  /**
   * Returns the top value.
   * @returns {number} the top value
   */
  getTop () {
    return this._top
  }

  /**
   * Sets the top value.
   * @param {number} top the top value
   * @returns {TopTransformation} this transformation
   * @package
   */
  setTop (top) {
    this._top = top
    return this
  }
}

module.exports = TopTransformation
