'use strict'

const AbstractError = require('../../odata-commons').errors.AbstractError

/**
 * @extends AbstractError
 */
class InternalServerError extends AbstractError {
  /**
   * Creates an instance of InternalServerError.
   * If an error message is not provided, the default message would be 'Internal server error'.
   *
   * @param {string} message The error message
   */
  constructor (message = 'Internal server error') {
    super(AbstractError.ErrorNames.INTERNAL_SERVER_ERROR, message)
  }
}

module.exports = InternalServerError
