'use strict'

const MetaProperties = require('../../odata-commons').format.JsonFormat.MetaProperties

class MetadataHandler {
  /**
   * This method is called when a metadata document request comes in.
   *
   * @param {OdataRequest} request the OData request
   * @param {OdataResponse} response the OData response
   * @param {Function} next The callback function with signature next(error, resultData).
   */
  static read (request, response, next) {
    const metadataETag = request.getService().getMetadataEtag()
    if (metadataETag) request.validateEtag(metadataETag)

    next(null, { [MetaProperties.ETAG]: metadataETag })
  }
}

module.exports = MetadataHandler
