'use strict'

/**
 * The `next` callback to be called upon finish execution.
 * @callback Command~Next
 * @param {?Error} [error] An error if there is one or null if not
 */

/**
 * Main abstract class for all commands.
 * @abstract
 */
class Command {
  /**
   * Creates an instance of Command
   * @param {Context} [context] The current odata context
   */
  constructor (context) {
    this._context = context
  }

  /**
   * Returns the current instance of the provided context.
   * @returns {Context} The current instance of odata context
   */
  getContext () {
    return this._context
  }
}

module.exports = Command
