/**
 * Convert any result to the result object structure, which is expected of rest.
 *
 * @param {*} result
 * @returns {string | object}
 */
const toRestResult = result => {
  let restResult = result

  // compat for mtx returning strings instead of objects
  if (typeof result === 'object' && '$count' in result) {
    restResult = {
      count: result.$count,
      value: result
    }
  }

  return restResult
}

module.exports = {
  toRestResult
}
