// REVISIT: why do we have processDeep and processDeepAsync?!
// REVISIT: replace all remaining usages of processDeep/processDeepAsync with new template mechanism

const { all } = require('../../common/utils/thenable')

const processDeep = (callbackFn, data, entity, skipRoot, isRoot) => {
  if (!Array.isArray(data)) {
    processDeep(callbackFn, [data], entity, skipRoot, isRoot)
    return
  }

  data.forEach(entry => {
    if (!(skipRoot && isRoot)) {
      callbackFn(entry, entity, isRoot, skipRoot)
    }

    for (const key in entity.elements) {
      const element = entity.elements[key]

      if (element.isComposition && entry[element.name]) {
        const subData = Array.isArray(entry[element.name]) ? entry[element.name] : [entry[element.name]]
        const subEntity = element._target
        processDeep(callbackFn, subData, subEntity, false, false)
      }
    }
  })
}

const _deepProcessWithDiffComposition = ({ entry, element, compositionTree, callbackFn }) => {
  const subData = Array.isArray(entry[element.name]) ? entry[element.name] : [entry[element.name]]
  const subEntity = element._target
  const compositionElement = compositionTree.compositionElements.find(({ name }) => name === element.name)

  processsDeepEnhanced({
    callbackFn,
    data: subData,
    parentEntry: entry,
    entity: subEntity,
    compositionTree: compositionElement
  })
}

const processsDeepEnhanced = ({ callbackFn, data, parentEntry, entity, compositionTree }) => {
  if (!Array.isArray(data)) {
    processsDeepEnhanced({ callbackFn, data: [data], parentEntry, entity, compositionTree })
    return
  }

  data.forEach(entry => {
    callbackFn({ entry, parentEntry, entity, compositionTree })

    for (const key in entity.elements) {
      const element = entity.elements[key]

      if (element.isComposition && entry[element.name]) {
        _deepProcessWithDiffComposition({ entry, element, compositionTree, callbackFn })
      }
    }
  })
}

const _deeperElements = (callbackFn, entry, elements = {}) => {
  return Object.keys(elements).map(key => {
    const element = elements[key]

    if (element.isComposition && entry[element.name]) {
      const subData = Array.isArray(entry[element.name]) ? entry[element.name] : [entry[element.name]]

      return processDeepAsync(callbackFn, subData, element._target, false, false)
    }
  })
}

const processDeepAsync = (callbackFn, data, entity, skipRoot, isRoot) => {
  if (!Array.isArray(data)) {
    return processDeepAsync(callbackFn, [data], entity, skipRoot, isRoot)
  }

  const deep = data.map(async entry => {
    if (!(skipRoot && isRoot)) {
      await callbackFn(entry, entity, isRoot)
    }

    return all(_deeperElements(callbackFn, entry, entity.elements))
  })

  return all(deep)
}

module.exports = {
  processDeep,
  processDeepAsync
}
