// global.cds is used on purpose here!
const cds = global.cds

const ODATA_CONTAINED = '@odata.contained'

const { isMandatory, isReadOnly } = require('./utils')

module.exports = class {
  get _isAssociationStrict() {
    const val = !!(this.isAssociation && !this.isComposition)
    super._isAssociationStrict = val
    return val
  }

  get _isAssociationEffective() {
    const val = this._isAssociationStrict && (!this[ODATA_CONTAINED] || this.name === 'DraftAdministrativeData')
    super._isAssociationEffective = val
    return val
  }

  get _isCompositionEffective() {
    const val =
      this.isComposition ||
      (this._isAssociationStrict && this[ODATA_CONTAINED] && this.name !== 'DraftAdministrativeData')
    super._isCompositionEffective = val
    return val
  }

  get _isStructured() {
    const val = !!this.elements && this.kind !== 'entity'
    // REVISIT: this does break nested structured types
    // super._isStructured = val
    return val
  }

  get _isContained() {
    const val =
      this.name !== 'DraftAdministrativeData_DraftUUID' &&
      ((this.isAssociation && this[ODATA_CONTAINED]) || (this.isComposition && cds.env.effective.odata.containment))
    super._isContained = val
    return val
  }

  get _isMandatory() {
    const val = !this.isAssociation && isMandatory(this)
    super._isMandatory = val
    return val
  }

  get _isReadOnly() {
    const val = !this.key && isReadOnly(this)
    super._isReadOnly = val
    return val
  }
}
