/*
// global.cds is used on purpose here!
const cds = global.cds
*/

let getSearchableColumns

module.exports = class {
  get _isSingleton() {
    const val = this['@odata.singleton'] || (this['@odata.singleton.nullable'] && this['@odata.singleton'] !== false)
    super._isSingleton = val
    return val
  }

  get _hasPersistenceSkip() {
    // REVISIT: checking !== 'if-unused' should not be necessary anymore
    const val = this['@cds.persistence.skip'] && this['@cds.persistence.skip'] !== 'if-unused'
    super._hasPersistenceSkip = val
    return val
  }

  // REVISIT: replace other helpers with this
  get _isDraftEnabled() {
    const val = this['@odata.draft.enabled'] || this['@Common.DraftNode.PreparationAction']
    super._isDraftEnabled = val
    return val
  }

  get _searchableColumns() {
    // lazily require on first use
    getSearchableColumns =
      getSearchableColumns || require('../../cds-services/services/utils/columns').getSearchableColumns
    const searchableColumns = getSearchableColumns(this)
    super._searchableColumns = searchableColumns
    return searchableColumns
  }

  get _etag() {
    let val
    for (const ele in this.elements) {
      if (this.elements[ele]['@odata.etag']) {
        val = ele
        break
      }
    }
    super._etag = val
    return val
  }
}
