const CommonFieldControl = e => {
  const cfr = e['@Common.FieldControl']
  return cfr && cfr['#']
}

const isMandatory = e => {
  return (
    e['@assert.mandatory'] !== false &&
    (e['@mandatory'] ||
      e['@Common.FieldControl.Mandatory'] ||
      e['@FieldControl.Mandatory'] ||
      CommonFieldControl(e) === 'Mandatory')
  )
}

const isReadOnly = e => {
  return (
    e.virtual ||
    e['@readonly'] ||
    e['@cds.on.update'] ||
    e['@cds.on.insert'] ||
    e['@Core.Computed'] ||
    e['@Common.FieldControl.ReadOnly'] ||
    e['@FieldControl.ReadOnly'] ||
    CommonFieldControl(e) === 'ReadOnly'
  )
}

module.exports = {
  isMandatory,
  isReadOnly
}
