const cds = require('../../../../cds')

const _require = require('../../../utils/require')

const getCredentials = uaa => {
  uaa = uaa || cds.env.requires.uaa || {}

  if (!uaa.credentials) {
    try {
      const vcap = cds.env.requires.uaa && cds.env.requires.uaa.vcap
      uaa.credentials = _require('@sap/xsenv').serviceCredentials(vcap || { label: 'xsuaa' })
    } catch (e) {
      const msg =
        'Unable to get xsuaa credentials. Please make sure your app is bound to a single xsuaa service instance or that you provide vcap information in the requires.uaa section.'
      // REVISIT: switch to verror
      throw Object.assign(new Error(msg), { original: e })
    }
  }

  return uaa.credentials
}

module.exports = {
  getCredentials
}
