const cds = require('../../cds')
const { getWriteAccessInfo, getReadAccessInfo } = require('../../audit/utils/personalReqData')

/**
 * Generic handler for audit logging access to writing personal data
 *
 * @param req
 */
const _writeHandler = async function (req) {
  const personalData = await getWriteAccessInfo(req)
  // REVISIT: Audit-log personal data
  req._personalData = personalData
}

/**
 * Generic handler for audit logging access to reading personal data
 *
 * @param req
 */
const _readHandler = async function (data, req) {
  const personalData = await getReadAccessInfo(data, req)
  // REVISIT: Audit-log personal data
  req._personalData = personalData
}

/*
 * handler registration
 */
module.exports = function () {
  if (cds.env.features.log_personal_data_access) {
    _writeHandler._initial = true
    this.before(['CREATE', 'UPDATE', 'DELETE'], _writeHandler)
    this.after(['READ'], _readHandler)
  }
}
