const _deepCopy = arg => {
  if (Buffer.isBuffer(arg)) {
    return Buffer.from(arg)
  }
  if (Array.isArray(arg)) {
    return deepCopyArray(arg)
  }
  if (typeof arg === 'object') {
    return deepCopyObject(arg)
  }
  return arg
}

const deepCopyArray = arr => {
  if (!arr) return arr
  const clone = []
  for (const item of arr) {
    clone.push(_deepCopy(item))
  }
  return clone
}

const deepCopyObject = obj => {
  if (!obj) return obj
  const clone = {}
  for (const key in obj) {
    clone[key] = _deepCopy(obj[key])
  }
  return clone
}

module.exports = {
  deepCopyObject,
  deepCopyArray
}
