const { hasDeepInsert, getDeepInsertCQNs } = require('../../common/composition')
const { getFlatArray, processCQNs } = require('../utils/deep')
const { timestampToISO } = require('../data-conversion/timestamp')

const insert = executeInsertCQN => async (model, dbc, query, req) => {
  const ts = timestampToISO(req.timestamp)

  if (hasDeepInsert(model && model.definitions, query)) {
    const cqns = getFlatArray(getDeepInsertCQNs(model && model.definitions, query))

    // return array of individual results
    if (cqns.length === 0) return []
    const results = await processCQNs(executeInsertCQN, cqns, model, dbc, req.user, req.user.locale, ts)
    return getFlatArray(results)
  }

  return executeInsertCQN(model, dbc, query, req.user, req.user.locale, ts)
}

module.exports = insert
