const { deleteDraft } = require('../utils/delete')

/**
 * Generic Handler for CANCEL requests.
 * In case of success it returns an empty object.
 * If the entry to be deleted does not exist, it rejects with error to return a 404.
 *
 * @param req
 */
const _handler = function (req) {
  return deleteDraft(req, this.model.definitions, false)
}

const { ODATA, COMMON } = require('../../common/constants/annotation')
const _relevant = e => e[ODATA.DRAFT] || e[COMMON.DRAFT_NODE.PREP_ACTION]

module.exports = function () {
  for (const entity of Object.values(this.entities).filter(_relevant)) {
    this.on('CANCEL', entity, _handler)
  }
}
